function IO( xhrOptions ) 
{
	if( xhrOptions == null || xhrOptions.onComplete == null )
		return;

	chrome.extension.sendRequest( { topic: "io", xhrOptions: xhrOptions }, function( msg ){
		xhrOptions.onComplete(msg.status, msg.data, msg.version);
	});
}

var includedScripts = {};

function askIncludeScript( partialURI, onComplete )
{
	if( includedScripts[ partialURI ] == true )
		return devhd.fn.callback( onComplete );

	try
	{
		IO(	{	method: 	"GET",
		  		url:  		chrome.extension.getURL( partialURI ),
		  		onComplete: function( status, data, version ) 
				{
	 				
					if (status == 200) 
					{
						try
						{
							window.eval.call( window, data );
						}
						catch( e )
						{
							$debug( "[page][load-script]" + partialURI + " failed because " + e.name + " -- " + e.message );
							throw e;
						}
					}
					includedScripts[ partialURI ] = true;
					
					devhd.fn.callback( onComplete );
				}
			});
	}
	catch( ignore )
	{
		
		// some files might not exist. no worries
	}
}

function include( partialURI )
{
	if( feedlyScripts[ partialURI ] == true )
		return;
	 
	// Load JS libraries
	var u = "chrome://feedly/content/app/" + partialURI;
	try
	{
		var jsl = Cc["@mozilla.org/moz/jssubscript-loader;1"]
						.getService(Ci.mozIJSSubScriptLoader);  
		
		jsl.loadSubScript( u );
	}
	catch( e )
	{
		feedlyScripts[ partialURI ] = true;

		$debug( "[loader] failed to load: " + u + " because <" + e.name + ": " + e.message + "> in " + e.fileName + "@" + e.lineNumber );
		throw e;
	}

}

var streets = null;
function loadFeedly() 
{
	// load and initialize the streets bus
	streets = devhd.streets.create();
	streets.setEnvironment( "chrome" );

	streets.addLink( { type:"cross-process" } );
	streets.attachDocument( document );	

	streets.load( feedlyStreets );
	
	streets.askStart( 	function()
						{
							chrome.extension.sendRequest( { topic: "observer-start", name: streets.pname }, function( cause ){
								reloadFeedly( cause );
								// document.location = "http://www.feedly.com/home";
							});

							streets.service( "feedly" ).loadStartPage();	
						},
						function( status )
						{
							document.getElementById( "loadingStatus" ).innerHTML = status;	
						}
						);
						
	window.addEventListener( "unload",  unloadFeedly, false ); 
}

function reloadFeedly( cause )
{
	$debug( "session event: " + cause );	
	unloadFeedly();
	loadFeedly();
}

function unloadFeedly()
{
	// load and initialize the streets bus
	streets.askShutdown();	

	window.removeEventListener( "unload",  unloadFeedly, false ); 
}



loadFeedly();
