/**
 * Args are the getopt args from the command line.
 * @param args
 * @return return a json config object
 *
 */

function watchdogConfiguration ( args ) {

    // Each entry has the following:
	//    name: name
	//     cmd: the command to start
	//    args: the arguments to the command line
	//    ping: the http url to ping for health of the started process. This may be missing in which case
	//          http pings will not be done.
    //
	// the watchdog will fill on other fields in each entry as it starts and manages the children.
	// most important of the is the pid, or the process id of the child process.

	var port = args.get("port");
    var i = 1;
    var M = (args.get("count") || 3)

	var config = { list: [] } ;

    // i=1 to M
    var entry, nextPort;
	for(i=1; i <= M; i++) {
		nextPort = port+i;
		//
		entry = {
			name : "node"+i ,
			cmd  : "node",
			args : [ "10101_node.js", "--port="+nextPort , "--child"] ,
		    pingURL : "http://localhost:" + nextPort + "/health"
		}
		// if test, we self start ... just to test.
        if (args.get("test")) {
        	entry.args = [ "10101_admin.js","--port="+nextPort,"--name="+entry.name,"--child", ];
        }
		config.list.push( entry )
	}
	return config;
}
